/*
 * Add a HTB Class.
 */
#include <glib.h>

#include "lql-con.h"
#include "lql-qdisc-htb.h"
#include "lql-class-htb.h"

int
main(int argc,
     char *argv[])
{
	LQLCon *con = NULL;
	LQLQDiscHTB *qdisc = NULL;
	LQLClassHTB *htb = NULL;

	g_type_init();

	con = (LQLCon *) lql_con_new();

	qdisc = (LQLQDiscHTB *)lql_qdisc_htb_new();
	lql_qdisc_set_parent(LQL_QDISC(qdisc), NULL);
	lql_qdisc_set_id(LQL_QDISC(qdisc), 1);
	lql_qdisc_htb_set_defaultClass(LQL_QDISC_HTB(qdisc), 1);
	lql_element_set_ifIndex(LQL_ELEMENT(qdisc), 2);
	if (!lql_qdisc_add(LQL_QDISC(qdisc), con)) {
		g_printerr("Could not add HTB QDisc.\n");
		return(-1);
	}

	htb = (LQLClassHTB *) lql_class_htb_new();
	lql_class_set_parent(LQL_CLASS(htb), LQL_ELEMENT(qdisc));
	lql_class_set_priority(LQL_CLASS(htb), 9);
	lql_class_set_id(LQL_CLASS(htb), 1);
	lql_element_set_ifIndex(LQL_ELEMENT(htb), 2);
	lql_class_htb_set_rate(htb, 10000000);
	lql_class_htb_set_ceiling(htb, 10000000);
	if (!lql_class_add(LQL_CLASS(htb), con)) {
		g_print("Could not add class.\n");
		return(FALSE);
	}

	// Cleanup.
	g_object_unref(con);
	g_object_unref(qdisc);
	g_object_unref(htb);

	return(0);
}
