/*
 * Add a PFIFO QDisc to interface index 3.
 */
#include <glib.h>

#include "lql-con.h"
#include "lql-qdisc.h"
#include "lql-qdisc-pfifo.h"

int
main(int argc,
     char *artv[])
{
	LQLCon *con = NULL;
	LQLQDiscPFIFO *qdisc = NULL;

	g_type_init();

	con = (LQLCon *)lql_con_new();
	qdisc = (LQLQDiscPFIFO *)lql_qdisc_pfifo_new();

	lql_qdisc_set_parent(LQL_QDISC(qdisc), NULL);
	lql_qdisc_set_id(LQL_QDISC(qdisc), 1);
	lql_element_set_ifIndex(LQL_ELEMENT(qdisc), 2);

	lql_qdisc_pfifo_set_queueLength(LQL_QDISC_PFIFO(qdisc), 8);

	lql_qdisc_add(LQL_QDISC(qdisc), con);
	
	g_object_unref(qdisc);
	g_object_unref(con);

	return(0);
}
