/*
 * Add a SFQ QDisc.
 */
#include <glib.h>

#include "lql-con.h"
#include "lql-qdisc.h"
#include "lql-qdisc-sfq.h"

int
main(int argc,
     char *artv[])
{
	LQLCon *con = NULL;
	LQLQDiscSFQ *qdisc = NULL;

	g_type_init();

	con = (LQLCon *)lql_con_new();
	qdisc = (LQLQDiscSFQ *)lql_qdisc_sfq_new();

	lql_qdisc_set_parent(LQL_QDISC(qdisc), NULL);
	lql_qdisc_set_id(LQL_QDISC(qdisc), 1);
	lql_element_set_ifIndex(LQL_ELEMENT(qdisc), 2);
	lql_qdisc_sfq_set_perturb(LQL_QDISC_SFQ(qdisc), 10);
	lql_qdisc_sfq_set_quantum(LQL_QDISC_SFQ(qdisc), 1900);

	if (!lql_qdisc_add(LQL_QDISC(qdisc), con)) {
		return(-1);
	}
	
	g_object_unref(qdisc);
	g_object_unref(con);

	return(0);
}
