/*
 * A messy large example.
 */
#include <unistd.h>

#include <glib.h>

#include "lql-con.h"
#include "lql-qdisc.h"
#include "lql-qdisc-htb.h"
#include "lql-qdisc-pfifofast.h"
#include "lql-qdisc-pfifo.h"
#include "lql-class.h"
#include "lql-class-htb.h"
#include "lql-interface.h"
#include "lql-classifier.h"
#include "lql-classifier-fwmark.h"

int
main(int argc,
     char *argv[])
{
	LQLCon *con = NULL;
	LQLQDiscHTB *qdisc = NULL;
	LQLClassHTB *htb = NULL, *htb2 = NULL;
	LQLInterface *interface = NULL;
	LQLClassifierFwmark *fwmark = NULL;
	GList *list;

	g_type_init();

	con = (LQLCon *)lql_con_new();

	// Get the interfaces and find the index of eth0.
	list = lql_con_get_interfaces(con);
	while (list != NULL) {
		interface = list->data;
		if (g_strcasecmp("eth0", lql_interface_get_name(interface)) == 0) {
			break;
		} else {
			g_object_unref(interface);
		}

		list = list->next;
	}
	g_list_free(list);

	// Add the HTB QDisc.
	qdisc = (LQLQDiscHTB *)lql_qdisc_htb_new();
	lql_qdisc_set_parent(LQL_QDISC(qdisc), NULL);
	lql_qdisc_set_id(LQL_QDISC(qdisc), 1);
	lql_qdisc_htb_set_defaultClass(LQL_QDISC_HTB(qdisc), 1);
	lql_element_set_ifIndex(LQL_ELEMENT(qdisc), lql_interface_get_ifIndex(interface));
	if (!lql_qdisc_add(LQL_QDISC(qdisc), con)) {
		g_printerr("Could not add qdisc.\n");
		return(-1);
	}

	// Add the first class.
	htb = (LQLClassHTB *) lql_class_htb_new();
	lql_class_set_parent(LQL_CLASS(htb), LQL_ELEMENT(qdisc));
	lql_class_set_priority(LQL_CLASS(htb), 0);
	lql_class_set_id(LQL_CLASS(htb), 1);
	lql_element_set_ifIndex(LQL_ELEMENT(htb), lql_interface_get_ifIndex(interface));
	lql_class_htb_set_rate(htb, 1250000);
	lql_class_htb_set_ceiling(htb, 1250000);
	if (!lql_class_add(LQL_CLASS(htb), con)) {
		g_printerr("Could not add class.\n");
		return(-1);
	}
	
	// Add the second class.
	htb2 = (LQLClassHTB *) lql_class_htb_new();
	lql_class_set_parent(LQL_CLASS(htb2), LQL_ELEMENT(qdisc));
	lql_class_set_priority(LQL_CLASS(htb2), 0);
	lql_class_set_id(LQL_CLASS(htb2), 2);
	lql_element_set_ifIndex(LQL_ELEMENT(htb2), lql_interface_get_ifIndex(interface));
	lql_class_htb_set_rate(htb2, 20000);
	lql_class_htb_set_ceiling(htb2, 20000);
	if (!lql_class_add(LQL_CLASS(htb2), con)) {
		g_print("Could not add class.\n");
		return(-1);
	}

	// Now add a classifer. Lets put 69.41.199.9 into class 2.
	fwmark = (LQLClassifierFwmark *)lql_classifier_fwmark_new();
	lql_classifier_set_priority(LQL_CLASSIFIER(fwmark), 5);
	lql_classifier_set_ifIndex(LQL_CLASSIFIER(fwmark),
				   lql_interface_get_ifIndex(interface));
	lql_classifier_set_class(LQL_CLASSIFIER(fwmark), LQL_CLASS(htb2));
	lql_classifier_set_parent(LQL_CLASSIFIER(fwmark), LQL_ELEMENT(qdisc));
	lql_classifier_set_id(LQL_CLASSIFIER(fwmark), 5);	
//	lql_classifier_fwmark_set_mark(LQL_CLASSIFIER_FWMARK(fwmark), 5);

	if (!lql_classifier_add(LQL_CLASSIFIER(fwmark), con)) {
		g_printerr("Could not add classifier.\n");
		return(-1);
	}

	// Get the number of QDiscs.
	list = lql_con_get_qdiscs(con, interface);
	g_print("Number of QDiscs: %i\n", g_list_length(list));
	while (list != NULL) {
		LQLQDisc *qdisc2 = NULL;
		qdisc2 = (LQLQDisc *)list->data;
		g_print("--------QDISC---------------\n");
		g_print("ID: %i\n", lql_qdisc_get_id(qdisc2));
//		g_print("Default class: %i\n", lql_qdisc_get_defaultClass(qdisc2));
		g_print("Parent: %i\n", lql_element_get_parentHandle(LQL_ELEMENT(qdisc2)));
		g_print("ifIndex: %i\n", lql_element_get_ifIndex(LQL_ELEMENT(qdisc2)));
		
		if (LQL_IS_QDISC_PFIFO(qdisc2)) {
			g_print("FIFO: %i\n",
				lql_qdisc_pfifo_get_queueLength(LQL_QDISC_PFIFO(qdisc2)));
		}

		list = list->next;
	}

	// Get the number of Classes.
	list = lql_con_get_classes(con, interface);
	g_print("Number of classes: %i\n", g_list_length(list));
	while (list != NULL) {
		LQLClass *class = NULL;
		class = (LQLClass *)list->data;
		g_print("---------CLASS--------------\n");
		g_print("ID: %i\n", lql_class_get_id(class));
		g_print("Parent: %i\n", lql_element_get_parentHandle(LQL_ELEMENT(class)));
		g_print("ifIndex: %i\n", lql_element_get_ifIndex(LQL_ELEMENT(class)));
		g_print("Rate: %i\n", lql_class_htb_get_rate(LQL_CLASS_HTB(class)));
		g_print("Ceil: %i\n", lql_class_htb_get_ceiling(LQL_CLASS_HTB(class)));
		
		list = list->next;
	}
	
	// Cleanup.
	g_object_unref(qdisc);
	g_object_unref(htb);
	g_object_unref(htb2);
	g_object_unref(fwmark);
	g_object_unref(interface);
	g_object_unref(con);

	return(0);
}
