/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_CLASS_DSMARK_H_
#define _LQL_CLASS_DSMARK_H_

#include <glib-object.h>
#include "nl.h"
#include "lql-class.h"

#define LQL_TYPE_CLASS_DSMARK (lql_class_dsmark_get_type ())
#define LQL_CLASS_DSMARK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LQL_TYPE_CLASS_DSMARK, LQLClassDSMark))
#define LQL_CLASS_DSMARK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LQL_TYPE_CLASS_DSMARK, LQLClassDSMarkClass))
#define LQL_IS_CLASS_DSMARK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LQL_TYPE_CLASS_DSMARK))
#define LQL_IS_CLASS_DSMARK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LQL_TYPE_CLASS_DSMARK))
#define LQL_CLASS_DSMARK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LQL_TYPE_CLASS_DSMARK, LQLClassDSMarkClass))

typedef struct _LQLClassDSMark LQLClassDSMark;
typedef struct _LQLClassDSMarkClass LQLClassDSMarkClass;
typedef struct _LQLClassDSMarkPrivate LQLClassDSMarkPrivate;

struct _LQLClassDSMark {
	LQLClass parent;

	/* Instance members */
        LQLClassDSMarkPrivate *private;
};

struct _LQLClassDSMarkClass {
	LQLClassClass parent;

	/* Class members */
};

/* used by LQL_TYPE_CLASS_DSMark */
GType lql_class_dsmark_get_type (void);

/* Non-virtual API. */
LQLClassDSMark* lql_class_dsmark_new(void);

guint8 lql_class_dsmark_get_mask(LQLClassDSMark *self);
gboolean lql_class_dsmark_set_mask(LQLClassDSMark *self, guint8 mask);

guint8 lql_class_dsmark_get_value(LQLClassDSMark *self);
gboolean lql_class_dsmark_set_value(LQLClassDSMark *self, guint8 value);

/* Virtual API. */

#endif /* _LQL_CLASS_DSMARK_H_ */
