/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_CLASS_HTB_H_
#define _LQL_CLASS_HTB_H_

#include <glib-object.h>
#include "nl.h"
#include "lql-class.h"

#define LQL_TYPE_CLASS_HTB (lql_class_htb_get_type ())
#define LQL_CLASS_HTB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), LQL_TYPE_CLASS_HTB, LQLClassHTB))
#define LQL_CLASS_HTB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), LQL_TYPE_CLASS_HTB, LQLClassHTBClass))
#define LQL_IS_CLASS_HTB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), LQL_TYPE_CLASS_HTB))
#define LQL_IS_CLASS_HTB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LQL_TYPE_CLASS_HTB))
#define LQL_CLASS_HTB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), LQL_TYPE_CLASS_HTB, LQLClassHTBClass))

typedef struct _LQLClassHTB LQLClassHTB;
typedef struct _LQLClassHTBClass LQLClassHTBClass;
typedef struct _LQLClassHTBPrivate LQLClassHTBPrivate;

struct _LQLClassHTB {
	LQLClass parent;

	/* Instance members */
        LQLClassHTBPrivate *private;
};

struct _LQLClassHTBClass {
	LQLClassClass parent;

	/* Class members */
};

/* used by LQL_TYPE_CLASS_HTB */
GType lql_class_htb_get_type (void);

/* Non-virtual API. */
LQLClassHTB* lql_class_htb_new(void);
unsigned int lql_class_htb_get_rate(LQLClassHTB *self);
gboolean lql_class_htb_set_rate(LQLClassHTB *self, unsigned int rate);
unsigned int lql_class_htb_get_ceiling(LQLClassHTB *self);
gboolean lql_class_htb_set_ceiling(LQLClassHTB *self, unsigned int ceiling);
unsigned int lql_class_htb_get_mtu(LQLClassHTB *self);
gboolean lql_class_htb_set_mtu(LQLClassHTB *self, unsigned int mtu);
unsigned int lql_class_htb_get_mpu(LQLClassHTB *self);
gboolean lql_class_htb_set_mpu(LQLClassHTB *self, unsigned int mpu);

/* Virtual API. */

#endif /* _LQL_CLASS_HTB_H_ */
