/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_CLASSIFIER_TCINDEX_H_
#define _LQL_CLASSIFIER_TCINDEX_H_

#include <glib-object.h>
#include "nl.h"
#include "lql-classifier.h"
#include "lql-class.h"

#define LQL_TYPE_CLASSIFIER_TCINDEX (lql_classifier_tcindex_get_type ())
#define LQL_CLASSIFIER_TCINDEX(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), LQL_TYPE_CLASSIFIER_TCINDEX, LQLClassifierTCIndex))
#define LQL_CLASSIFIER_TCINDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), LQL_TYPE_CLASSIFIER_TCINDEX, LQLClassifierTCIndexClass))
#define LQL_IS_CLASSIFIER_TCINDEX(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), LQL_TYPE_CLASSIFIER_TCINDEX))
#define LQL_IS_CLASSIFIER_TCINDEX_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), LQL_TYPE_CLASSIFIER_TCINDEX))
#define LQL_CLASSIFIER_TCINDEX_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), LQL_TYPE_CLASSIFIER_TCINDEX, LQLClassifierTCIndexClass))

typedef struct _LQLClassifierTCIndex LQLClassifierTCIndex;
typedef struct _LQLClassifierTCIndexClass LQLClassifierTCIndexClass;
typedef struct _LQLClassifierTCIndexPrivate LQLClassifierTCIndexPrivate;

struct _LQLClassifierTCIndex {
	LQLClassifier parent;

	/* Instance members */
        LQLClassifierTCIndexPrivate *private;
};

struct _LQLClassifierTCIndexClass {
	LQLClassifierClass parent;

	/* Class members */
};

/* used by LQL_TYPE_CLASSIFIER_TCINDEX */
GType lql_classifier_tcindex_get_type (void);

/* Non-virtual API. */
LQLClassifierTCIndex* lql_classifier_tcindex_new(void);

guint32 lql_classifier_tcindex_get_hash(LQLClassifierTCIndex *self);
gboolean lql_classifier_tcindex_set_hash(LQLClassifierTCIndex *self, guint32 hash);

guint32 lql_classifier_tcindex_get_mask(LQLClassifierTCIndex *self);
gboolean lql_classifier_tcindex_set_mask(LQLClassifierTCIndex *self, guint32 mask);

guint32 lql_classifier_tcindex_get_shift(LQLClassifierTCIndex *self);
gboolean lql_classifier_tcindex_set_shift(LQLClassifierTCIndex *self, guint32 shift);

gboolean lql_classifier_tcindex_get_fallThrough(LQLClassifierTCIndex *self);
gboolean lql_classifier_tcindex_set_fallThrough(LQLClassifierTCIndex *self, gboolean fallThrough);

guint32 lql_classifier_tcindex_get_classHandle(LQLClassifierTCIndex *self);
gboolean lql_classifier_tcindex_set_class(LQLClassifierTCIndex *self, LQLClass *class);

/* Virtual API. */

#endif /* _LQL_CLASSIFIER_TCINDEX_H_ */
