/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_INTERFACE_H_
#define _LQL_INTERFACE_H_

#include <glib-object.h>
#include "nl.h"

#define LQL_TYPE_INTERFACE		  (lql_interface_get_type ())
#define LQL_INTERFACE(obj)		  (G_TYPE_CHECK_INSTANCE_CAST ((obj), LQL_TYPE_INTERFACE, LQLInterface))
#define LQL_INTERFACE_CLASS(klass)	  (G_TYPE_CHECK_CLASS_CAST ((klass), LQL_TYPE_INTERFACE, LQLInterfaceClass))
#define LQL_IS_INTERFACE(obj)	  (G_TYPE_CHECK_TYPE ((obj), LQL_TYPE_INTERFACE))
#define LQL_IS_INTERFACE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), LQL_TYPE_INTERFACE))
#define LQL_INTERFACE_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), LQL_TYPE_INTERFACE, LQLInterfaceClass))

typedef struct _LQLInterface LQLInterface;
typedef struct _LQLInterfaceClass LQLInterfaceClass;
typedef struct _LQLInterfacePrivate LQLInterfacePrivate;

struct _LQLInterface {
	GObject parent;

	/* Instance members */
        LQLInterfacePrivate *private;
};

struct _LQLInterfaceClass {
	GObjectClass parent;

	/* Class members */
};

/* used by LQL_TYPE_INTERFACE */
GType lql_interface_get_type (void);

/* Non-virtual API. */
LQLInterface* lql_interface_new(void);
int lql_interface_get_ifIndex(LQLInterface *self);
gboolean lql_interface_set_ifIndex(LQLInterface *self, int ifIndex);
int lql_interface_get_mtu(LQLInterface *self);
gboolean lql_interface_set_mtu(LQLInterface *self, int mtu);
gchar* lql_interface_get_name(LQLInterface *self);
gboolean lql_interface_set_name(LQLInterface *self, const gchar *name);
gboolean lql_interface_fill_from_nlhdr(LQLInterface *self, const struct nlmsghdr *hdr);

/* Virtual API. */

#endif /* _LQL_INTERFACE_H_ */
