/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_QDISC_HTB_H_
#define _LQL_QDISC_HTB_H_

#include <glib-object.h>
#include "nl.h"
#include "lql-qdisc.h"

#define LQL_TYPE_QDISC_HTB (lql_qdisc_htb_get_type ())
#define LQL_QDISC_HTB(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), LQL_TYPE_QDISC_HTB, LQLQDiscHTB))
#define LQL_QDISC_HTB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), LQL_TYPE_QDISC_HTB, LQLQDiscHTBClass))
#define LQL_IS_QDISC_HTB(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), LQL_TYPE_QDISC_HTB))
#define LQL_IS_QDISC_HTB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), LQL_TYPE_QDISC_HTB))
#define LQL_QDISC_HTB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), LQL_TYPE_QDISC_HTB, LQLQDiscHTBClass))

typedef struct _LQLQDiscHTB LQLQDiscHTB;
typedef struct _LQLQDiscHTBClass LQLQDiscHTBClass;
typedef struct _LQLQDiscHTBPrivate LQLQDiscHTBPrivate;

struct _LQLQDiscHTB {
	LQLQDisc parent;

	/* Instance members */
        LQLQDiscHTBPrivate *private;
};

struct _LQLQDiscHTBClass {
	LQLQDiscClass parent;

	/* Class members */
};

/* used by LQL_TYPE_QDISC_HTB */
GType lql_qdisc_htb_get_type (void);

/* Non-virtual API. */
LQLQDiscHTB* lql_qdisc_htb_new(void);
guint32 lql_qdisc_htb_get_defaultClass(LQLQDiscHTB *self);
gboolean lql_qdisc_htb_set_defaultClass(LQLQDiscHTB *self, guint32 defaultClass);
guint32 lql_qdisc_htb_get_rateToQuantum(LQLQDiscHTB *self);
gboolean lql_qdisc_htb_set_rateToQuantum(LQLQDiscHTB *self, guint32 rateToQuantum);
guint32 lql_qdisc_htb_get_directPackets(LQLQDiscHTB *self);

/* Virtual API. */

#endif /* _LQL_QDISC_HTB_H_ */
