/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_QDISC_NETEM_H_
#define _LQL_QDISC_NETEM_H_

#include <glib-object.h>
#include "nl.h"
#include "lql-qdisc.h"

#define LQL_TYPE_QDISC_NETEM (lql_qdisc_netem_get_type())
#define LQL_QDISC_NETEM(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), LQL_TYPE_QDISC_NETEM, LQLQDiscNetem))
#define LQL_QDISC_NETEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), LQL_TYPE_QDISC_NETEM, LQLQDiscNetemClass))
#define LQL_IS_QDISC_NETEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), LQL_TYPE_QDISC_NETEM))
#define LQL_IS_QDISC_NETEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), LQL_TYPE_QDISC_NETEM))
#define LQL_QDISC_NETEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), LQL_TYPE_QDISC_NETEM, LQLQDiscNetemClass))

typedef struct _LQLQDiscNetem LQLQDiscNetem;
typedef struct _LQLQDiscNetemClass LQLQDiscNetemClass;
typedef struct _LQLQDiscNetemPrivate LQLQDiscNetemPrivate;

struct _LQLQDiscNetem {
	LQLQDisc parent;

	/* Instance members */
        LQLQDiscNetemPrivate *private;
};

struct _LQLQDiscNetemClass {
	LQLQDiscClass parent;

	/* Class members */
};

/* used by LQL_TYPE_QDISC_NETEM */
GType lql_qdisc_netem_get_type (void);

/* Non-virtual API. */
LQLQDiscNetem* lql_qdisc_netem_new(void);

guint32 lql_qdisc_netem_get_latency(LQLQDiscNetem *self);
gboolean lql_qdisc_netem_set_latency(LQLQDiscNetem *self, guint32 latency);

guint32 lql_qdisc_netem_get_limit(LQLQDiscNetem *self);
gboolean lql_qdisc_netem_set_limit(LQLQDiscNetem *self, guint32 limit);

float lql_qdisc_netem_get_loss(LQLQDiscNetem *self);
gboolean lql_qdisc_netem_set_loss(LQLQDiscNetem *self, float loss);

guint32 lql_qdisc_netem_get_gap(LQLQDiscNetem *self);
gboolean lql_qdisc_netem_set_gap(LQLQDiscNetem *self, guint32 gap);

float lql_qdisc_netem_get_duplicate(LQLQDiscNetem *self);
gboolean lql_qdisc_netem_set_duplicate(LQLQDiscNetem *self, float duplicate);

guint32 lql_qdisc_netem_get_jitter(LQLQDiscNetem *self);
gboolean lql_qdisc_netem_set_jitter(LQLQDiscNetem *self, guint32 jitter);

float lql_qdisc_netem_get_latencyCorrelation(LQLQDiscNetem *self);
gboolean lql_qdisc_netem_set_latencyCorrelation(LQLQDiscNetem *self, float latency);

float lql_qdisc_netem_get_lossCorrelation(LQLQDiscNetem *self);
gboolean lql_qdisc_netem_set_lossCorrelation(LQLQDiscNetem *self, float loss);

float lql_qdisc_netem_get_duplicateCorrelation(LQLQDiscNetem *self);
gboolean lql_qdisc_netem_set_duplicateCorrelation(LQLQDiscNetem *self, float duplicate);

/* Virtual API. */

#endif /* _LQL_QDISC_NETEM_H_ */
