/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_QDISC_SFQ_H_
#define _LQL_QDISC_SFQ_H_

#include <glib-object.h>
#include "nl.h"
#include "lql-qdisc.h"

#define LQL_TYPE_QDISC_SFQ (lql_qdisc_sfq_get_type ())
#define LQL_QDISC_SFQ(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), LQL_TYPE_QDISC_SFQ, LQLQDiscSFQ))
#define LQL_QDISC_SFQ_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), LQL_TYPE_QDISC_SFQ, LQLQDiscSFQClass))
#define LQL_IS_QDISC_SFQ(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), LQL_TYPE_QDISC_SFQ))
#define LQL_IS_QDISC_SFQ_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), LQL_TYPE_QDISC_SFQ))
#define LQL_QDISC_SFQ_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), LQL_TYPE_QDISC_SFQ, LQLQDiscSFQClass))

typedef struct _LQLQDiscSFQ LQLQDiscSFQ;
typedef struct _LQLQDiscSFQClass LQLQDiscSFQClass;
typedef struct _LQLQDiscSFQPrivate LQLQDiscSFQPrivate;

struct _LQLQDiscSFQ {
	LQLQDisc parent;

	/* Instance members */
        LQLQDiscSFQPrivate *private;
};

struct _LQLQDiscSFQClass {
	LQLQDiscClass parent;

	/* Class members */
};

/* used by LQL_TYPE_QDISC_SFQ */
GType lql_qdisc_sfq_get_type (void);

/* Non-virtual API. */
LQLQDiscSFQ* lql_qdisc_sfq_new(void);
int lql_qdisc_sfq_get_perturb(LQLQDiscSFQ *self);
gboolean lql_qdisc_sfq_set_perturb(LQLQDiscSFQ *self, int perturb);
unsigned lql_qdisc_sfq_get_quantum(LQLQDiscSFQ *self);
gboolean lql_qdisc_sfq_set_quantum(LQLQDiscSFQ *self, unsigned int quantum);

/* Virtual API. */

#endif /* _LQL_QDISC_SFQ_H_ */
