/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_U32MATCH_H_
#define _LQL_U32MATCH_H_

#include <glib-object.h>
#include "nl.h"
#include "lql-con.h"

#define LQL_TYPE_U32MATCH (lql_u32match_get_type ())
#define LQL_U32MATCH(obj) (G_TYPE_CHECK_INSTANCE_CAST((obj), LQL_TYPE_U32MATCH, LQLU32Match))
#define LQL_U32MATCH_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST((klass), LQL_TYPE_U32MATCH, LQLU32MatchClass))
#define LQL_IS_U32MATCH(obj) (G_TYPE_CHECK_INSTANCE_TYPE((obj), LQL_TYPE_U32MATCH))
#define LQL_IS_U32MATCH_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass), LQL_TYPE_U32MATCH))
#define LQL_U32MATCH_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS((obj), LQL_TYPE_U32MATCH, LQLU32MatchClass))

typedef struct _LQLU32Match LQLU32Match;
typedef struct _LQLU32MatchClass LQLU32MatchClass;
typedef struct _LQLU32MatchPrivate LQLU32MatchPrivate;

struct _LQLU32Match {
	GObject parent;

	/* Instance members */
        LQLU32MatchPrivate *private;
};

struct _LQLU32MatchClass {
	GObjectClass parent;

	/* Class members */
};

/* used by LQL_TYPE_U32MATCH */
GType lql_u32match_get_type (void);

/* Non-virtual API. */
LQLU32Match* lql_u32match_new(void);

guint32 lql_u32match_get_value(LQLU32Match *self);
gboolean lql_u32match_set_value(LQLU32Match *self, guint32 value);
guint32 lql_u32match_get_mask(LQLU32Match *self);
gboolean lql_u32match_set_mask(LQLU32Match *self, guint32 mask);
int lql_u32match_get_off(LQLU32Match *self);
gboolean lql_u32match_set_off(LQLU32Match *self, int off);
int lql_u32match_get_offset(LQLU32Match *self);
gboolean lql_u32match_set_offset(LQLU32Match *self, int offset);

/* Virtual API. */

#endif /* _LQL_U32MATCH_H_ */
