/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef _LQL_CLASSIFIER_U32_HELPER_
#define _LQL_CLASSIFIER_U32_HELPER_

#include <glib.h>

#include "lql-classifier-u32.h"
#include "lql-u32match.h"

gboolean lql_classifier_u32_helper_set_handle(LQLClassifierU32 *classifier, guint16 handle);
guint16 lql_classifier_u32_helper_get_handle(LQLClassifierU32 *classifier);
gboolean lql_classifier_u32_helper_set_hashHandle(LQLClassifierU32 *classifier, guint16 hashHandle);
guint16 lql_classifier_u32_helper_get_hashHandle(LQLClassifierU32 *classifier);
gboolean lql_classifier_u32_helper_set_hashNode(LQLClassifierU32 *classifier, guint16 hashNode);
guint16 lql_classifier_u32_helper_get_hashNode(LQLClassifierU32 *classifier);
gboolean lql_classifier_u32_helper_fill_from_nlhdr(LQLClassifierU32 *u32, const struct nlmsghdr *hdr);
gboolean lql_classifier_u32_helper_add(LQLClassifierU32 *u32, LQLCon *con);
gboolean lql_classifier_u32_helper_modify(LQLClassifierU32 *u32, LQLCon *con);

gboolean lql_classifier_u32_helper_add_match(LQLClassifierU32 *u32, LQLU32Match *match);
gboolean lql_classifier_u32_helper_add_match_ip_dst(LQLClassifierU32 *u32, const gchar *ip);
LQLU32Match* lql_classifier_u32_helper_get_match(LQLClassifierU32 *u32, int position);
int lql_classifier_u32_helper_get_match_len(LQLClassifierU32 *u32);

#endif
