/*
 * Copyright (C) 2004 Dan Siemon <dan@coverfire.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#include <unistd.h>

#include "nl.h"

#include "lql-interface.h"
//#include "lql-interface-private.h"

gboolean
lql_interface_helper_fill_from_nlhdr(LQLInterface *interface,
				     const struct nlmsghdr *hdr)
{
	g_assert(interface != NULL);
	g_assert(hdr != NULL);
	
	lql_interface_set_ifIndex(interface, nl_ifinfo_get_index(hdr));
	lql_interface_set_name(interface,
			       (char *)nl_ifinfo_get_rta_val(hdr, IFLA_IFNAME));
	lql_interface_set_mtu(interface,
			      *((int *)nl_ifinfo_get_rta_val(hdr, IFLA_MTU)));

	return(TRUE);
}

